
# math
class math:
    pi = 3.1415926
    e = 2.7182818
    ln2 = 0.6931471
    ln10 = 2.3025851
    log2e = 1.4426950
    log10e = 0.4342945
    sqrt1_2 = 0.7071068
    sqrt2 = 1.4142135

    @staticmethod
    def sqrt(x: float) -> float:
        """ 返回 x 的平方根 | Return the square root of x """
        return 0

    @staticmethod
    def cbrt(x: float) -> float:
        """ 返回 x 的立方根 | Return the cube root of x """
        return 0

    @staticmethod
    def pow(x: float, a: float) -> float:
        """ 返回 x 的 a 次幂 | Return x to the power of a """
        return 0

    @staticmethod
    def clamp(value: float, min_val: float, max_val: float) -> float:
        """ 返回 value 被限制在 min_val 和 max_val 之间 | Return value limited between min_val and max_val """
        return 0

    @staticmethod
    def sign(x: float) -> int:
        """ 返回 x 的符号 | Return the sign of x """
        return 0

    @staticmethod
    def sin(r: float) -> float:
        """ 返回 r 弧度的正弦值 | Return the sine of r radians """
        return 0

    @staticmethod
    def cos(r: float) -> float:
        """ 返回 r 弧度的余弦值 | Return the cosine of r radians """
        return 0

    @staticmethod
    def tan(r: float) -> float:
        """ 返回 r 弧度的正切值 | Return the tangent of r radians """
        return 0

    @staticmethod
    def cot(r: float) -> float:
        """ 返回 r 弧度的余切值 | Return the cotangent of r radians """
        return 0

    @staticmethod
    def asin(r: float) -> float:
        """ 返回 r 弧度的反正弦值 | Return the arcsine of r radians """
        return 0

    @staticmethod
    def acos(r: float) -> float:
        """ 返回 r 弧度的反余弦值 | Return the arccosine of r radians """
        return 0

    @staticmethod
    def atan(r: float) -> float:
        """ 返回 r 弧度的反正切值 | Return the arctangent of r radians """
        return 0

    @staticmethod
    def atan2(y: float, x: float) -> float:
        """ 返回 y/x 弧度的反正切值 | Return the arctangent of y/x radians """
        return 0

    @staticmethod
    def acot(r: float) -> float:
        """ 返回 r 弧度的反余切值 | Return the arccotangent of r radians """
        return 0

    @staticmethod
    def degree(r: float) -> float:
        """ 返回 r 弧度的度数 | Return the degree of r radians """
        return 0

    @staticmethod
    def radian(r: float) -> float:
        """ 返回 r 度数的弧度 | Return the radian of r degrees """
        return 0

    @staticmethod
    def min(*x: float) -> float:
        """ 返回 x 中最小的值 | Return the smallest value in *x """
        return 0

    @staticmethod
    def max(*x: float) -> float:
        """ 返回 x 中最大的值 | Return the largest value in *x """
        return 0

    @staticmethod
    def abs(x: float) -> float:
        """ 返回 x 的绝对值 | Return the absolute value of x """
        return 0

    @staticmethod
    def floor(x: float) -> float:
        """ 返回 x 的整数部分 | Return the integer part of x """
        return 0

    @staticmethod
    def ceil(x: float) -> float:
        """ 返回 x 的整数部分 | Return the integer part of x """
        return 0

    @staticmethod
    def round(x: float) -> float:
        """ 返回 x 的四舍五入值 | Return the rounded value of x """
        return 0

    @staticmethod
    def trunc(x: float) -> float:
        """ 返回 x 的截断值 | Return the truncated value of x """
        return 0

    @staticmethod
    def log(x: float) -> float:
        """ 返回 x 的自然对数 | Return the natural logarithm of x """
        return 0

    @staticmethod
    def log2(x: float) -> float:
        """ 返回以2为底的 x 的对数 | Return the logarithm of x with base 2 """
        return 0

    @staticmethod
    def log10(x: float) -> float:
        """ 返回以10为底的 x 的对数 | Return the logarithm of x with base 10 """
        return 0

    @staticmethod
    def exp(x: float) -> float:
        """ 返回 e 的 x 次方 | Return e to the power of x """
        return 0

    @staticmethod
    def epsilon(a: float, b: float) -> bool:
        """ 如果 a 和 b 之间的差异小于 0.000001，则返回 true | Return true if the difference between a and b is less than 0.000001 """
        return True

    @staticmethod
    def random(n: float = 1.0) -> float:
        """ 返回 0 到 n 之间的随机浮点数 | Return a random floating point number between 0 and n """
        return 0

    @staticmethod
    def irandom(n: float) -> int:
        """ 返回 0 到 n 之间的随机整数 | Return a random integer between 0 and n """
        return 0

    @staticmethod
    def randint(min: float, max: float) -> int:
        """ 返回 min 到 max 之间的随机整数 | Return a random integer between min and max """
        return 0

    @staticmethod
    def randfloat(min: float, max: float) -> float:
        """ 返回 min 到 max 之间的随机浮点数 | Return a random floating point number between min and max """
        return 0

    @staticmethod
    def randrange(min: float, max: float, step: float = None) -> float:
        """ 返回 min 到 max 之间的随机浮点数, 随机步长为 step(可选) | Return a random floating point number between min and max, with a random step of step (optional) """
        return 0

    @staticmethod
    def irandrange(min: float, max: float, step: int = None) -> int:
        """ 返回 min 到 max 之间的随机整数, 随机步长为 step(可选) | Return a random integer between min and max, with a random step of step (optional) """
        return 0

    @staticmethod
    def choice(arr: list) -> object:
        """ 从数组中随机选择一个元素 | Randomly select an element from the array """
        return 0

    @staticmethod
    def sample(arr: list, n: int = 1) -> list:
        """ 从数组中随机选择 n 个元素，不允许重复选择 | Randomly select n elements from the array, no duplicates allowed """
        return []

    @staticmethod
    def shuffle(arr: list) -> None:
        """ 随机打乱数组(改变数组) | Shuffle the array randomly (change the array) """
        return

