// > sort 2

var ARENA_NAME = arenaInfo["name"];
var ARENA_LEVEL = arenaInfo["level"];
var ARENA_SEASON = arenaInfo["season"];
var ARENA_TICKS_LIMIT = arenaInfo["ticksLimit"];
var ARENA_CPU_TIME_LIMIT = arenaInfo["cpuTimeLimit"];
var ARENA_CPU_TIME_LIMIT_FIRST_TICK = arenaInfo["cpuTimeLimitFirstTick"];
export var UsrObject =  __class__ ('UsrObject', [object], {
	__module__: __name__,
});
export var Point =  __class__ ('Point', [object], {
	__module__: __name__,
	exists: true,
	get __init__ () {return __get__ (this, function (self, x, y) {
		self.x = x;
		self.y = y;
	});},

	get __str__ () {return __get__ (this, function (self) {
		return 'Point(' + self.x + ', ' + self.y + ')';
	});},
});

var P = Point;
export var std =  {
	_expand_composite_as_list:function (filter_composite) {
		var _ = [];
		if (isinstance (filter_composite, tuple ([tuple, list]))) {
			for (var each of filter_composite) {
				_.extend (std._expand_composite_as_list (each));
			}
			return _;
		}
		else if (isinstance (filter_composite, set)) {
			return std._expand_composite_as_list (py_next (py_iter (filter_composite)));
		}
		else {
			return [filter_composite];
		}
	},
	_generate_combo_js_eval:function (filter_composite, fid) {
		if (isinstance (filter_composite, list)) {
			return ('(' + ' || '.join ((function () {
				var __accu0__ = [];
				for (var each of filter_composite) {
					__accu0__.append (std._generate_combo_js_eval (each, fid));
				}
				return py_iter (__accu0__);
			}) ())) + ')';
		}
		else if (isinstance (filter_composite, tuple)) {
			return ('(' + ' && '.join ((function () {
				var __accu0__ = [];
				for (var each of filter_composite) {
					__accu0__.append (std._generate_combo_js_eval (each, fid));
				}
				return py_iter (__accu0__);
			}) ())) + ')';
		}
		else if (isinstance (filter_composite, set)) {
			return (' !(' + std._generate_combo_js_eval (py_next (py_iter (filter_composite)), fid)) + ')';
		}
		else {
			return ('%' + fid [filter_composite]) + '%';
		}
	},
	_expand_memory: dict ({}),
	combo:function (filter_composite) {
		var memory_key = str (filter_composite);
		var fn = std._expand_memory.py_get (memory_key, null);
		if (fn) {
			return fn;
		}
		var fn_ids = dict ({});
		var id_fns = dict ({});
		var _ = std._expand_composite_as_list (filter_composite);
		for (var [f_id, each_fn] of enumerate (set (_))) {
			f_id++;
			var __left0__ = tuple ([f_id, each_fn]);
			fn_ids [each_fn] = f_id;
			id_fns [f_id] = __left0__ [1];
		}
		var _eval_str = std._generate_combo_js_eval (filter_composite, fn_ids);
		var _inner = function (obj) {
			var eval_str = _eval_str + '';
			for (var [fn_id, func] of id_fns.py_items ()) {
				eval_str = eval_str.replace('%' + fn_id + '%', String(!!func(obj)));
				// pass;
			}
			return eval (eval_str);
		};
		std._expand_memory [memory_key] = _inner;
		return _inner;
	},
	log:function (caller_name) {
		var args = tuple ([].slice.apply (arguments).slice (1));
		console.log("[" + caller_name, "[33m" + "Log" + "[0m" + "]:", ...args)
		// pass;
	},
	info:function (caller_name) {
		var args = tuple ([].slice.apply (arguments).slice (1));
		console.log("[" + caller_name, "[42m" + "Info" + "[0m" + "]:", ...args)
		// pass;
	},
	warn:function (caller_name) {
		var args = tuple ([].slice.apply (arguments).slice (1));
		console.log("[" + caller_name, "[43m" + "Warn" + "[0m" + "]:", ...args)
		// pass;
	},
	error:function (caller_name) {
		var args = tuple ([].slice.apply (arguments).slice (1));
		throw new Error("[" + caller_name + "[41m" + "Warn" + "[0m" + "]: " + args.join(" "))
		// pass;
	},
	_show_usage_flag: false,
	_cpu_limit: Math.floor (ARENA_CPU_TIME_LIMIT / 1000),
	_cpu_first_limit: Math.floor (ARENA_CPU_TIME_LIMIT_FIRST_TICK / 1000000),
	show_usage:function () {
		print ('');
		var game_tick = get.ticks ();
		if (!(std._show_usage_flag)) {
			if (game_tick >= 1) {
				std._show_usage_flag = true;
			}
			var info = get.arena ();
			var arena_name = info.py_name.__getslice__ (0, 2, 1).lower ();
			var color = '\x1b[42m';
			if (arena_name === 'ca') {
				var color = '\x1b[44m';
			}
			else if (arena_name === 'co') {
				var color = '\x1b[43m';
			}
			print ((((((color + '---------- 欢迎来到') + '\x1b[35m') + 'Screeps Arena') + '\x1b[37m') + '! ----------') + '\x1b[0m');
			print ((('编译器版本: ' + __version__) + ', ') + 'Python版本: 3.12.1', '\n');
		}
		print ('[性能使用情况]');
		if (game_tick <= 1) {
			var v = round (get.cpu () / 1000000);
			var color = (v < 800 ? (v < 600 ? '\x1b[32m' : '\x1b[33m') : '\x1b[31m');
			print ('cpu: ', (color + str (v)) + '\x1b[0m', 'ms / {} ms'.format (std._cpu_first_limit));
		}
		else {
			var v = round (get.cpu () / 1000);
			var color = (v < 40000 ? (v < 30000 ? '\x1b[32m' : '\x1b[33m') : '\x1b[31m');
			print ('cpu: ', (color + str (v)) + '\x1b[0m', 'us / {} us'.format (std._cpu_limit));
		}
		var heap = get.heap ();
		var v = round (heap.used_heap_size / 1024);
		var v_limit = round (heap.heap_size_limit / 1024);
		var color = (v < v_limit * 0.6 ? '\x1b[32m' : (v < v_limit * 0.8 ? '\x1b[33m' : '\x1b[31m'));
		print ('内存:', (color + str (v)) + '\x1b[0m', 'KB /', v_limit, 'KB');
	},
}